
# -------------------------------------------------------------------
# the authentication module

sub authenticate_parse_cookie() 
{
	my $ck; # return value
	my $key;
	my $value;
	my ($unam,$upwd);
	my ($snam,$scrypt);

	$ck=0;

	@cookies=split (/;\s/,$ENV{'HTTP_COOKIE'}); # split cookies into table
    foreach $line (@cookies)
	{
		($key,$value)=split (/=/,$line);
		if ($key eq "user") { $unam=$value; }
		if ($key eq "pwd") { $upwd=$value; }
	}

	($snam,$scrypt,$foo)=getpwnam($unam); # get system password.
	$salt=substr($scrypt,0,2);
	$ucrypt=crypt($upwd,$salt);
	
	if (($unam ne "") && ($snam eq $unam) && ($ucrypt eq $scrypt)) { $ck=1; }
    return ($ck);
}


sub authenticate_user() # print login screen
{
	print &html_login_screen();
	exit 0;
}

sub authenticate_setcookie()
{
	my ($unam,$upwd)=@_;
	print "Content-Type: text/html\n";
	($ci)=authenticate_chk_user($unam,$upwd);
 
        if ($ci==0)
        {
                print "Set-Cookie: user=".$unam.";","\n";
                print "Set-Cookie: pwd=".$upwd.";","\n\n";
       
				print &html_display_root_frame();
                exit 0;
        } else {
				print "\n";

				print &html_badlogin();
                exit 0;
        }
}

sub authenticate_chk_user() # check if password is right.
{
	my ($unam,$upwd)=@_;
	my ($snam,$scrypt);
	my $ck;

	$ck=0;
	($snam,$scrypt,$foo)=getpwnam($unam);
	$salt=substr($scrypt,0,2);
	$ucrypt=crypt($upwd,$salt);

	if ($ucrypt eq $scrypt) { $ck=0; } else { $ck=1;}	

	$whoami=`/usr/bin/whoami`; # check that the user is who he claims to be
	chomp $whoami;
	if ($unam ne $whoami)	{ $ck=1; }

	return ($ck);
}

sub authenticate_logout() 
{
        print "Content-Type: text/html\n"; 
        print "Set-Cookie: user=;","\n";
        print "Set-Cookie: pwd=;","\n\n";
        print &html_head();

		print "<center><br><br>";
		print &html_notify("Logout...",'You have loged out.<br><br>Click <a href="webmh.cgi">login</a> to login again.');

		print '</center>';
        print &html_tail();
        exit 0;
}

# -------------------------------------------------------------------

1;

